// addin.cpp : Implementation of Caddin
#include "stdafx.h"
#include "OutlookAddin.h"
#include "addin.h"

/////////////////////////////////////////////////////////////////////////////
// Caddin
#define APP_NAME        L"Sync4j Outlook Client"
#define AMP_SYNC4J      TEXT("&Sync4j")      
STDMETHODIMP Caddin::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_Iaddin
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP Caddin::OnConnection(IDispatch * Application, ext_ConnectMode ConnectMode, IDispatch * AddInInst, SAFEARRAY * * custom) {
     
    CComVariant vEmpty(DISP_E_PARAMNOTFOUND, VT_ERROR);

    _ApplicationPtr spApp(Application);    
    _ExplorerPtr    spExplorer;
    CComPtr <Office::_CommandBars> spCmdBars;
    VARIANT variant;
	variant.vt = VT_BSTR;
   
    CommandBarControlPtr commandBarControlPtr;
    spApp->ActiveExplorer(&spExplorer);
   
	HRESULT hRes = spExplorer->get_CommandBars(&spCmdBars); 
    if(FAILED(hRes)) {        
        return hRes;
    }
   
    CommandBarPtr spCmdBar;
	   	
	variant.bstrVal = SysAllocString(APP_NAME);
	
    hRes = spCmdBars->get_Item(variant,&spCmdBar);
	
    VariantClear(&variant);
   
    if (SUCCEEDED(hRes)) {
        hRes = spCmdBar->Delete();
    } 
    
    //
    // remove the sync4j bar
    //

    CommandBarPopupPtr pMenuItem; 
    CComPtr < Office::CommandBarControls> spCmdCtrls;
    CComPtr < Office::CommandBarControl> spCmdCtrl;
    
    // get CommandBar that is Outlook's main menu
    HRESULT hr = spCmdBars->get_ActiveMenuBar(&spCmdBar); 

    if (FAILED(hr)) {
        return hr;
    }
        
    spCmdCtrls = spCmdBar->GetControls(); 
    ATLASSERT(spCmdCtrls);
    
    hr = spCmdCtrls->get_Item(CComVariant(AMP_SYNC4J), &spCmdCtrl);   

    
    if (SUCCEEDED(hr)) {
        CommandBarPopupPtr pMenuItem; 
        pMenuItem = spCmdBars->ActiveMenuBar->Controls->GetItem(AMP_SYNC4J);
        pMenuItem->Delete(vtMissing);

    }   

    DllUnregisterServer();

    return S_OK;
}